récupération coordonnés + nom d'un point en drafting

Voir le sujet précédent Voir le sujet suivant Aller en bas

récupération coordonnés + nom d'un point en drafting

Message par haythem le Ven 6 Sep 2013 - 3:17

Bonjour à tous !

j'explique mon besoin :
j'utilise catia V5 R19 ServicePack 4

sur un Drafting Catia, avec la fonction (Cotations de coordonnées), on peut récupérer les coordonnées d'un point sur une part, or, j'aurais besoin du nom du point à coter des coordonnées.
donc serait-il possible, par le billet d'une macro, de combiner la fonction (Cotations de coordonnées) et l'affichage du nom du point séléctioné sur le 2D !

http://i71.servimg.com/u/f71/18/51/05/98/captur10.png

info: je débute avec les macro, j'ai l’habitude de les utiliser mais pas de les créer Smile
merci par avance !

haythem
timide
timide

Messages : 2
Date d'inscription : 06/09/2013
Localisation : tunisie

Revenir en haut Aller en bas

Re: récupération coordonnés + nom d'un point en drafting

Message par Guss_ le Sam 7 Sep 2013 - 0:37

Je pense que ça doit être possible,

Essaye déjà de faire un enregistrement de ce que tu fais (outil > macro > démarrer enregistrement ... )

Guss_
Fédérateur
Fédérateur

Messages : 498
Date d'inscription : 08/01/2010

Revenir en haut Aller en bas

Re: récupération coordonnés + nom d'un point en drafting

Message par mike688 le Mar 10 Sep 2013 - 20:41

alors perso j'ai deja essayer, mais pas reussi si tu y parviens je veux bien la soluce.

pour ma part c'est plus de  partir d'un point en 3D,  projeté en 2D, je veux retrouver son nom dans le 3D pour y attacher un text en 2D.
"Point A", Pöint B etc...

le meilleur apprentissage passera par la programation "objet" a savoir.

exemple :

Code:

Dim fichier As DrawingDocument
Set fichier = CATIA.ActiveDocument
'en plaçant un espion sur la variable "Fichier", tu verra toute arborescence,

Dim dessin As DrawingRoot
Set dessin = fichier.DrawingRoot
Dim feuille As DrawingSheet
Set feuille = dessin.ActiveSheet
Dim vues As DrawingViews
Dim vue As DrawingView
Set vues = feuille.views
Set vue = vues.ActiveView

si maintenant il ne te faut que la vue active a chaque foi tu peu tout combiner. ex :
Set vue = CATIA.ActiveDocument.DrawingRoot.ActiveSheet.DrawingViews.ActiveView




le dimensionement des variables te permet d'aller plus vite car l'editeur te proposera les possibilité relative au type d'objet.
je crois que c'est ce qu'on appel l'intelisence

la fenêtre espion est très importante pour progresser
l'apprentissage par enregistrement, même si pour commencer c'est bien, ça complique vite la vie. car il faut faire beaucoup de tri
avatar
mike688
actif
actif

Messages : 255
Date d'inscription : 23/12/2009
Age : 35
Localisation : Portieux (88)

Revenir en haut Aller en bas

Re: récupération coordonnés + nom d'un point en drafting

Message par Guss_ le Mar 10 Sep 2013 - 20:50

Oui la fenêtre d'espionnage, c'est primordiale (même si elle n'est pas franchement ergonomique) pour l'enregistrement c'est déjà pour avoir une base de code qui peut permettre d'aiguillé vers quoi chercher

Guss_
Fédérateur
Fédérateur

Messages : 498
Date d'inscription : 08/01/2010

Revenir en haut Aller en bas

Re: récupération coordonnés + nom d'un point en drafting

Message par Mr.J le Ven 11 Oct 2013 - 8:03

Le plus gros problème c'est de faire le lien entre les éléments du 2D et du 3D.

Le VBA ne t'offre aucun lien entre ces deux mondes. Si tu sélectionnes un point dans le draw, au mieux tu peux obtenir ses coordonnées (X,Y) dans la vue et le nom de la Part qui a servi à générer la vue.

En revanche il est possible de récupérer ces infos dans le 3D. La solution est alors de récupérer l'ensemble de ces infos dans le 3D et les poser automatiquement dans le 2D, mais il faut alors faire attention à l'orientation de la vue. Est-ce que c'est ce que tu souhaites faire ?

En attendant je te propose un bout de code permettant de récupérer toutes ces infos en faisant une sélection dans le 3D. En espérant que cela t'aides un peu :

Code:

Sub CATMain()

'Récupère l'objet sélection CATIA
Dim Sel
Set Sel = CATIA.ActiveDocument.Selection

'Demande à l'utilisateur de sélectionner un point
MsgBox "Sélectionnez un point après avoir cliquer sur OK"

'Demande la selection à CATIA
Dim FilterType(0), Result
FilterType(0) = "ZeroDim"
Result = Sel.SelectElement2(FilterType, "Sélectionnez un point", False)

If Result = "Cancel" Then
    'Aucune sélection
    Exit Sub
Else
    'Récupère le point sélectionné
    Dim MySelectedPoint
    Set MySelectedPoint = Sel.Item2(1).Value
    
    'Récupère le nom du point
    Dim MyPointName
    MyPointName = MySelectedPoint.Name
    
    'Récupère les coordonnées du point
    Dim X As Double, Y As Double, Z As Double, Coords(2)
    MySelectedPoint.GetCoordinates Coords
    X = Coords(0)
    Y = Coords(1)
    Z = Coords(2)
    
    'Affiche les infos à l'utilisateur
    MsgBox "Point sélectioné : " & vbLf & _
           "Nom : " & MyPointName & vbLf & _
           "X : " & X & vbLf & _
           "Y : " & Y & vbLf & _
           "Z : " & Z

End If
Mr.J

Mr.J
timide
timide

Messages : 14
Date d'inscription : 11/10/2013
Localisation : Toulouse

Revenir en haut Aller en bas

Re: récupération coordonnés + nom d'un point en drafting

Message par Contenu sponsorisé


Contenu sponsorisé


Revenir en haut Aller en bas

Voir le sujet précédent Voir le sujet suivant Revenir en haut

- Sujets similaires

 
Permission de ce forum:
Vous ne pouvez pas répondre aux sujets dans ce forum